classification
Title: Sporadic test_threading failure on FreeBSD 6.4 buildbot
Type: behavior Stage: resolved
Components: Tests Versions: Python 3.3
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: nadeem.vawda, neologix, pitrou, python-dev
Priority: normal Keywords: buildbot, patch

Created on 2012-01-29 13:53 by nadeem.vawda, last changed 2012-03-25 08:38 by neologix. This issue is now closed.

Files
File name Uploaded Description Edit
freebsd_tls_spurious.diff neologix, 2012-03-24 10:33 review
Messages (5)
msg152226 - (view) Author: Nadeem Vawda (nadeem.vawda) * (Python committer) Date: 2012-01-29 13:53
http://www.python.org/dev/buildbot/all/builders/x86%20FreeBSD%206.4%203.x/builds/2206/steps/test/logs/stdio

    FAIL: test_6_daemon_threads (test.test_threading.ThreadJoinOnShutdown)
    ----------------------------------------------------------------------
    Traceback (most recent call last):
      File "/usr/home/db3l/buildarea/3.x.bolen-freebsd/build/Lib/test/test_threading.py", line 675, in test_6_daemon_threads
        self.assertFalse(err)
    AssertionError: b'[52879 refs]\nT' is not false
msg156689 - (view) Author: Charles-François Natali (neologix) * (Python committer) Date: 2012-03-24 10:33
And here's the full message:
"""
======================================================================
FAIL: test_6_daemon_threads (test.test_threading.ThreadJoinOnShutdown)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/usr/home/db3l/buildarea/3.2.bolen-freebsd/build/Lib/test/test_threading.py", line 667, in test_6_daemon_threads
    self.assertFalse(err)
AssertionError: b'[46830 refs]\nThread 85d0600 has exited with leftover thread-specific data after 4 destructor iterations' is not false
"""

It's actually a bug in FreeBSD < 7 pthread implementation, see http://lists.freebsd.org/pipermail/freebsd-threads/2009-June/004563.html

The patch attached simply skips this test on FreeBSD 6 (like many other similar tests do).
msg156693 - (view) Author: Nadeem Vawda (nadeem.vawda) * (Python committer) Date: 2012-03-24 13:26
Patch looks good to me.
msg156716 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2012-03-24 19:37
New changeset 2456e4e69cd0 by Charles-François Natali in branch '3.2':
Issue #13902: Fix a random test_threading failure on FreeBSD 6 buildbots (due
http://hg.python.org/cpython/rev/2456e4e69cd0

New changeset c1191cbc7b37 by Charles-François Natali in branch 'default':
Issue #13902: Fix a random test_threading failure on FreeBSD 6 buildbots (due
http://hg.python.org/cpython/rev/c1191cbc7b37
msg156742 - (view) Author: Charles-François Natali (neologix) * (Python committer) Date: 2012-03-25 08:38
Should be fixed now.
History
Date User Action Args
2012-03-25 08:38:14neologixsetstatus: open -> closed
resolution: fixed
messages: + msg156742

stage: needs patch -> resolved
2012-03-24 19:37:44python-devsetnosy: + python-dev
messages: + msg156716
2012-03-24 13:26:48nadeem.vawdasetmessages: + msg156693
2012-03-24 10:33:06neologixsetfiles: + freebsd_tls_spurious.diff

nosy: + neologix
messages: + msg156689

keywords: + patch
2012-01-29 13:53:30nadeem.vawdacreate